<!doctype html>
<html class="default no-js">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>Server | Bitcoin one way channel</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="../assets/css/main.css">
</head>
<body>
<header>
	<div class="tsd-page-toolbar">
		<div class="container">
			<div class="table-wrap">
				<div class="table-cell" id="tsd-search" data-index="../assets/js/search.js" data-base="..">
					<div class="field">
						<label for="tsd-search-field" class="tsd-widget search no-caption">Search</label>
						<input id="tsd-search-field" type="text" />
					</div>
					<ul class="results">
						<li class="state loading">Preparing search index...</li>
						<li class="state failure">The search index is not available</li>
					</ul>
					<a href="../index.html" class="title">Bitcoin one way channel</a>
				</div>
				<div class="table-cell" id="tsd-widgets">
					<div id="tsd-filter">
						<a href="#" class="tsd-widget options no-caption" data-toggle="options">Options</a>
						<div class="tsd-filter-group">
							<div class="tsd-select" id="tsd-filter-visibility">
								<span class="tsd-select-label">All</span>
								<ul class="tsd-select-list">
									<li data-value="public">Public</li>
									<li data-value="protected">Public/Protected</li>
									<li data-value="private" class="selected">All</li>
								</ul>
							</div>
							<input type="checkbox" id="tsd-filter-inherited" checked />
							<label class="tsd-widget" for="tsd-filter-inherited">Inherited</label>
							<input type="checkbox" id="tsd-filter-externals" checked />
							<label class="tsd-widget" for="tsd-filter-externals">Externals</label>
							<input type="checkbox" id="tsd-filter-only-exported" />
							<label class="tsd-widget" for="tsd-filter-only-exported">Only exported</label>
						</div>
					</div>
					<a href="#" class="tsd-widget menu no-caption" data-toggle="menu">Menu</a>
				</div>
			</div>
		</div>
	</div>
	<div class="tsd-page-title">
		<div class="container">
			<ul class="tsd-breadcrumb">
				<li>
					<a href="../globals.html">Globals</a>
				</li>
				<li>
					<a href="server.html">Server</a>
				</li>
			</ul>
			<h1>Class Server</h1>
		</div>
	</div>
</header>
<div class="container container-main">
	<div class="row">
		<div class="col-8 col-content">
			<section class="tsd-panel tsd-comment">
				<div class="tsd-comment tsd-typography">
					<div class="lead">
						<p>The server channel class can interact with an one way channel as a server.
							This class expose all the necessary methods to create, verify and sign all
						the possible transactions for the channel.</p>
					</div>
				</div>
			</section>
			<section class="tsd-panel tsd-hierarchy">
				<h3>Hierarchy</h3>
				<ul class="tsd-hierarchy">
					<li>
						<a href="protocol.html" class="tsd-signature-type">Protocol</a>
						<ul class="tsd-hierarchy">
							<li>
								<span class="target">Server</span>
							</li>
						</ul>
					</li>
				</ul>
			</section>
			<section class="tsd-panel-group tsd-index-group">
				<h2>Index</h2>
				<section class="tsd-panel tsd-index-panel">
					<div class="tsd-index-content">
						<section class="tsd-index-section ">
							<h3>Constructors</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-constructor tsd-parent-kind-class tsd-is-overwrite"><a href="server.html#constructor" class="tsd-kind-icon">constructor</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Properties</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-property tsd-parent-kind-class"><a href="server.html#kernel" class="tsd-kind-icon">kernel</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Methods</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="server.html#cosignsettlementtransaction" class="tsd-kind-icon">cosign<wbr>Settlement<wbr>Transaction</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="server.html#createrevokerefund" class="tsd-kind-icon">create<wbr>Revoke<wbr>Refund</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="server.html#createsettlementtransaction" class="tsd-kind-icon">create<wbr>Settlement<wbr>Transaction</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="server.html#signrefundtransaction" class="tsd-kind-icon">sign<wbr>Refund<wbr>Transaction</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited"><a href="server.html#transactionhextobuilder" class="tsd-kind-icon">transaction<wbr>Hex<wbr>ToBuilder</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="server.html#verifysignature" class="tsd-kind-icon">verify<wbr>Signature</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static"><a href="server.html#generateseed" class="tsd-kind-icon">generate<wbr>Seed</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static"><a href="server.html#revhashfromsecret" class="tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret</a></li>
							</ul>
						</section>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Constructors</h2>
				<section class="tsd-panel tsd-member tsd-kind-constructor tsd-parent-kind-class tsd-is-overwrite">
					<a name="constructor" class="tsd-anchor"></a>
					<h3>constructor</h3>
					<ul class="tsd-signatures tsd-kind-constructor tsd-parent-kind-class tsd-is-overwrite">
						<li class="tsd-signature tsd-kind-icon">new <wbr>Server<span class="tsd-signature-symbol">(</span>serverPrivKey<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, clientPubKey<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, accountId<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, net<span class="tsd-signature-symbol">?: </span><a href="../globals.html#networkname" class="tsd-signature-type">NetworkName</a>, api<span class="tsd-signature-symbol">?: </span><a href="../globals.html#apiname" class="tsd-signature-type">ApiName</a>, blocksInFuture<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="server.html" class="tsd-signature-type">Server</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<p>Overrides <a href="protocol.html">Protocol</a>.<a href="protocol.html#constructor">constructor</a></p>
								<ul>
									<li>Defined in lib/protocol/Server.ts:23</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create channel used to interact between the client and server.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>serverPrivKey: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the server root key in base58</p>
										</div>
									</div>
								</li>
								<li>
									<h5>clientPubKey: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the client public key for the
											same path m/44&#39;/0&#39;/[accountId]&#39;</p>
										</div>
									</div>
								</li>
								<li>
									<h5>accountId: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the channel id between the client and the
											server</p>
										</div>
									</div>
								</li>
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> net: <a href="../globals.html#networkname" class="tsd-signature-type">NetworkName</a><span class="tsd-signature-symbol"> =&nbsp;&quot;testnet&quot;</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network identifier</p>
										</div>
									</div>
								</li>
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> api: <a href="../globals.html#apiname" class="tsd-signature-type">ApiName</a><span class="tsd-signature-symbol"> =&nbsp;&quot;btcrpc&quot;</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the api used to query the network</p>
										</div>
									</div>
								</li>
								<li>
									<h5>blocksInFuture: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the locktime used for the channel</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="server.html" class="tsd-signature-type">Server</a></h4>
							<p>the channel used to interact with the server</p>
						</li>
					</ul>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Properties</h2>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class">
					<a name="kernel" class="tsd-anchor"></a>
					<h3>kernel</h3>
					<div class="tsd-signature tsd-kind-icon">kernel<span class="tsd-signature-symbol">:</span> <a href="serverkernel.html" class="tsd-signature-type">ServerKernel</a></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/protocol/Server.ts:23</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>Represent the kernel of the channel. Used to store the primitives like
							the keys.</p>
						</div>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Methods</h2>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="cosignsettlementtransaction" class="tsd-anchor"></a>
					<h3>cosign<wbr>Settlement<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">cosign<wbr>Settlement<wbr>Transaction<span class="tsd-signature-symbol">(</span>transactionHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/protocol/Server.ts:140</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>This method is used to cosign to the settlement transaction. The method is
										used by the server to fully sign the settlement transaction before
										broadcast it. The transaction is sign for the state i. The state i is used
									to reconstruct the multisig contract.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>transactionHex: <span class="tsd-signature-type">string</span></h5>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the index i used to recreate the multisig address</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span></h4>
							<p>the fully sign settlement transaction</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="createrevokerefund" class="tsd-anchor"></a>
					<h3>create<wbr>Revoke<wbr>Refund</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">create<wbr>Revoke<wbr>Refund<span class="tsd-signature-symbol">(</span>utxosAndWifs<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span><span class="tsd-signature-symbol">[]</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, feePerByte<span class="tsd-signature-symbol">: </span><a href="btc.html" class="tsd-signature-type">Btc</a>, recipientAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, revSecret<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="../interfaces/tx.html" class="tsd-signature-type">Tx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/protocol/Server.ts:188</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a revokation transaction if the client broadcast a old refund
										transaction. The transaction spend all the utxos present in the multisig
										for index i and send it to the settlement address. This transaction is
									valid only if the server knows the revokation secret.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxosAndWifs: <span class="tsd-signature-type">object</span><span class="tsd-signature-symbol">[]</span></h5>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the index i used to create the multisig index</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount of fee per byte for the crafted
											transactions</p>
										</div>
									</div>
								</li>
								<li>
									<h5>recipientAddress: <span class="tsd-signature-type">string</span></h5>
								</li>
								<li>
									<h5>revSecret: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the secret used in the revPubKey contract</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="../interfaces/tx.html" class="tsd-signature-type">Tx</a></h4>
							<p>a channel transaction containing the revoke refund transaction
							fully signed</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="createsettlementtransaction" class="tsd-anchor"></a>
					<h3>create<wbr>Settlement<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">create<wbr>Settlement<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxos<span class="tsd-signature-symbol">: </span><a href="../interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, n<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, refundtxHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, revHashString<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, providerAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, settlementAmount<span class="tsd-signature-symbol">: </span><a href="btc.html" class="tsd-signature-type">Btc</a>, changeAmount<span class="tsd-signature-symbol">: </span><a href="btc.html" class="tsd-signature-type">Btc</a>, feePerByte<span class="tsd-signature-symbol">: </span><a href="btc.html" class="tsd-signature-type">Btc</a><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/protocol/Server.ts:246</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Generate the settlement and post settlement transaction for the given
										refund when the client want to send an amount to the provider. The server
										receive the refund transaction with an amount and create the settlement
										and post settlement transaction with the right i and n. The server return
										the settlement, post settlement and the signed refund transactions with
									the next this.channel address.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxos: <a href="../interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the utxos used to create the settlement transaction,
											must be the same as the refund transaction</p>
										</div>
									</div>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the current index i, used to unlock the utxos</p>
										</div>
									</div>
								</li>
								<li>
									<h5>n: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the secret index n</p>
										</div>
									</div>
								</li>
								<li>
									<h5>refundtxHex: <span class="tsd-signature-type">string</span></h5>
								</li>
								<li>
									<h5>revHashString: <span class="tsd-signature-type">string</span></h5>
								</li>
								<li>
									<h5>providerAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the address used to send the funds to the
											provider</p>
										</div>
									</div>
								</li>
								<li>
									<h5>settlementAmount: <a href="btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount send to the provider</p>
										</div>
									</div>
								</li>
								<li>
									<h5>changeAmount: <a href="btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount send to the revPubKey contract</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount of fee used to create the transactions</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">object</span></h4>
							<p>the signed refund transaction, the settlement, the post
							settlement transaction and the next multisig address</p>
							<ul class="tsd-parameters">
								<li class="tsd-parameter">
									<h5>next<wbr>Channel<wbr>Address<span class="tsd-signature-symbol">: </span><a href="../interfaces/channeladdress.html" class="tsd-signature-type">ChannelAddress</a></h5>
								</li>
								<li class="tsd-parameter">
									<h5>post<wbr>Settlement<wbr>TxHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></h5>
								</li>
								<li class="tsd-parameter">
									<h5>refund<wbr>TxHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></h5>
								</li>
								<li class="tsd-parameter">
									<h5>settlement<wbr>TxHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></h5>
								</li>
							</ul>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="signrefundtransaction" class="tsd-anchor"></a>
					<h3>sign<wbr>Refund<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">sign<wbr>Refund<wbr>Transaction<span class="tsd-signature-symbol">(</span>transactionHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, secretHash<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/protocol/Server.ts:80</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Sign a refund transaction. For first refund transaction we do not have
										the signature of funding transaction so cannot verify it. For all future
										refund transactions the signatures of the transaction inputs should be
									verified.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>transactionHex: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the raw transaction to hex format</p>
										</div>
									</div>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the index i used to create the multisig index</p>
										</div>
									</div>
								</li>
								<li>
									<h5>secretHash: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the secret has used in the revPubKey contract</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span></h4>
							<p>the signed transaction to hex format</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-inherited">
					<a name="transactionhextobuilder" class="tsd-anchor"></a>
					<h3>transaction<wbr>Hex<wbr>ToBuilder</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-inherited">
						<li class="tsd-signature tsd-kind-icon">transaction<wbr>Hex<wbr>ToBuilder<span class="tsd-signature-symbol">(</span>transactionHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">TransactionBuilder</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<p>Inherited from <a href="protocol.html">Protocol</a>.<a href="protocol.html#transactionhextobuilder">transactionHexToBuilder</a></p>
								<ul>
									<li>Defined in lib/protocol/Protocol.ts:59</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>transactionHex: <span class="tsd-signature-type">string</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">TransactionBuilder</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="verifysignature" class="tsd-anchor"></a>
					<h3>verify<wbr>Signature</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">verify<wbr>Signature<span class="tsd-signature-symbol">(</span>transactionHex<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, signatureToBeVerified<span class="tsd-signature-symbol">?: </span><span class="tsd-signature-type">"provider"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"client"</span>, contract<span class="tsd-signature-symbol">?: </span><span class="tsd-signature-type">"multisig"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"revPubkey"</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/protocol/Server.ts:314</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>transactionHex: <span class="tsd-signature-type">string</span></h5>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
								</li>
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> signatureToBeVerified: <span class="tsd-signature-type">"provider"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"client"</span><span class="tsd-signature-symbol"> =&nbsp;&quot;client&quot;</span></h5>
								</li>
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> contract: <span class="tsd-signature-type">"multisig"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"revPubkey"</span><span class="tsd-signature-symbol"> =&nbsp;&quot;multisig&quot;</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">object</span></h4>
							<ul class="tsd-parameters">
								<li class="tsd-parameter">
									<h5>verified<wbr>Script<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></h5>
								</li>
								<li class="tsd-parameter">
									<h5>verified<wbr>Signature<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></h5>
								</li>
							</ul>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static">
					<a name="generateseed" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagStatic">Static</span> generate<wbr>Seed</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static">
						<li class="tsd-signature tsd-kind-icon">generate<wbr>Seed<span class="tsd-signature-symbol">(</span>network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<p>Inherited from <a href="protocol.html">Protocol</a>.<a href="protocol.html#generateseed">generateSeed</a></p>
								<ul>
									<li>Defined in lib/protocol/Protocol.ts:41</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Generate a seed for the given network.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to generate a node and serialize
											it</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span></h4>
							<p>the seed</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static">
					<a name="revhashfromsecret" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagStatic">Static</span> rev<wbr>Hash<wbr>From<wbr>Secret</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static">
						<li class="tsd-signature tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret<span class="tsd-signature-symbol">(</span>s<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<p>Inherited from <a href="protocol.html">Protocol</a>.<a href="protocol.html#revhashfromsecret">revHashFromSecret</a></p>
								<ul>
									<li>Defined in lib/protocol/Protocol.ts:52</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Compute the hash from a secret.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>s: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the secret to hash
											it</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span></h4>
							<p>the reuslted hash</p>
						</li>
					</ul>
				</section>
			</section>
		</div>
		<div class="col-4 col-menu menu-sticky-wrap menu-highlight">
			<nav class="tsd-navigation primary">
				<ul>
					<li class="globals  ">
						<a href="../globals.html"><em>Globals</em></a>
					</li>
				</ul>
			</nav>
			<nav class="tsd-navigation secondary menu-sticky">
				<ul class="before-current">
				</ul>
				<ul class="current">
					<li class="current tsd-kind-class">
						<a href="server.html" class="tsd-kind-icon">Server</a>
						<ul>
							<li class=" tsd-kind-constructor tsd-parent-kind-class tsd-is-overwrite">
								<a href="server.html#constructor" class="tsd-kind-icon">constructor</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class">
								<a href="server.html#kernel" class="tsd-kind-icon">kernel</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="server.html#cosignsettlementtransaction" class="tsd-kind-icon">cosign<wbr>Settlement<wbr>Transaction</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="server.html#createrevokerefund" class="tsd-kind-icon">create<wbr>Revoke<wbr>Refund</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="server.html#createsettlementtransaction" class="tsd-kind-icon">create<wbr>Settlement<wbr>Transaction</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="server.html#signrefundtransaction" class="tsd-kind-icon">sign<wbr>Refund<wbr>Transaction</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-inherited">
								<a href="server.html#transactionhextobuilder" class="tsd-kind-icon">transaction<wbr>Hex<wbr>ToBuilder</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="server.html#verifysignature" class="tsd-kind-icon">verify<wbr>Signature</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static">
								<a href="server.html#generateseed" class="tsd-kind-icon">generate<wbr>Seed</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-inherited tsd-is-static">
								<a href="server.html#revhashfromsecret" class="tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret</a>
							</li>
						</ul>
					</li>
				</ul>
				<ul class="after-current">
				</ul>
			</nav>
		</div>
	</div>
</div>
<footer class="with-border-bottom">
	<div class="container">
		<h2>Legend</h2>
		<div class="tsd-legend-group">
			<ul class="tsd-legend">
				<li class="tsd-kind-module"><span class="tsd-kind-icon">Module</span></li>
				<li class="tsd-kind-object-literal"><span class="tsd-kind-icon">Object literal</span></li>
				<li class="tsd-kind-variable"><span class="tsd-kind-icon">Variable</span></li>
				<li class="tsd-kind-function"><span class="tsd-kind-icon">Function</span></li>
				<li class="tsd-kind-function tsd-has-type-parameter"><span class="tsd-kind-icon">Function with type parameter</span></li>
				<li class="tsd-kind-index-signature"><span class="tsd-kind-icon">Index signature</span></li>
				<li class="tsd-kind-type-alias"><span class="tsd-kind-icon">Type alias</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-enum"><span class="tsd-kind-icon">Enumeration</span></li>
				<li class="tsd-kind-enum-member"><span class="tsd-kind-icon">Enumeration member</span></li>
				<li class="tsd-kind-property tsd-parent-kind-enum"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-enum"><span class="tsd-kind-icon">Method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-interface"><span class="tsd-kind-icon">Interface</span></li>
				<li class="tsd-kind-interface tsd-has-type-parameter"><span class="tsd-kind-icon">Interface with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-interface"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-interface"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-interface"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-interface"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-class"><span class="tsd-kind-icon">Class</span></li>
				<li class="tsd-kind-class tsd-has-type-parameter"><span class="tsd-kind-icon">Class with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-class"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class"><span class="tsd-kind-icon">Accessor</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-class"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-constructor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static property</span></li>
				<li class="tsd-kind-call-signature tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static method</span></li>
			</ul>
		</div>
	</div>
</footer>
<div class="container tsd-generator">
	<p>Generated using <a href="http://typedoc.org/" target="_blank">TypeDoc</a></p>
</div>
<div class="overlay"></div>
<script src="../assets/js/main.js"></script>
<script>if (location.protocol == 'file:') document.write('<script src="../assets/js/search.js"><' + '/script>');</script>
</body>
</html>